/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   main.c                                             :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angouleme.fr  +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/12/12 17:20:17 by cchauvet          #+#    #+#             */
/*   Updated: 2023/01/10 18:33:10 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "solong.h"

int	ft_initialised(char *path)
{
	t_data	*data;
	t_map	*map;

	data = ft_calloc(1, sizeof(t_data));
	if (data == NULL)
	{
		ft_printf("Memory error");
		return (1);
	}
	map = ft_getmap(path);
	if (map == NULL)
	{
		free(data);
		ft_printf("Map error\n");
		exit(1);
	}
	data->map = map;
	data->mlx = mlx_init();
	data->window = mlx_new_window(data->mlx, WINDOW_SIZE, WINDOW_SIZE, "");
	ft_draw_map(data);
	mlx_hook(data->window, 17, (0L), ft_exit, data);
	mlx_hook(data->window, 3, (1L << 1), ft_key, data);
	mlx_loop(data->mlx);
	return (0);
}

int	ft_exit(t_data *data)
{
	t_map	*map;

	map = data->map;
	ft_freer_tab_ultimate(1, map->patern);
	mlx_destroy_window(data->mlx, data->window);
	mlx_destroy_display(data->mlx);
	free(data->mlx);
	free(data);
	free(map);
	exit(0);
	return (0);
}

int	main(int ac, char **av)
{
	if (ac != 2)
	{
		ft_printf("Map error\n");
		return (1);
	}
	ft_printf("Generating assets ...\n");
	ft_gen_assets();
	ft_printf("Generating assets [FINISHED]\n");
	if (ft_initialised(av[1]))
		ft_printf("Memory error");
	return (1);
}
